﻿namespace UltraGridExportSummaryRows
{
    using System;
    using System.Data;
    using System.Diagnostics;
    using System.Windows.Forms;

    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.SetDataBinding(this.GetData(), "Main");
            this.ultraGrid1.Rows.ExpandAll(true);
        }

        private void UltraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["Price"].Formula = "Sum([Quantity] * [UnitPrice])";

            e.Layout.Bands[0].SortedColumns.Add(e.Layout.Bands[0].Columns["Type"], false, true);

            e.Layout.Bands[0].Columns["Quantity"].CellClickAction = CellClickAction.CellSelect;
            e.Layout.Bands[0].Columns["UnitPrice"].CellClickAction = CellClickAction.CellSelect;

            e.Layout.Bands[0].Summaries.Add("SUM([Price])", SummaryPosition.UseSummaryPositionColumn, e.Layout.Bands[0].Columns["Price"]);
        }

        private void ButtonExport_Click(object sender, EventArgs e)
        {
            string fileName = "test.xls";
            this.ultraGridExcelExporter1.Export(this.ultraGrid1, fileName);
            Process.Start(fileName);
        }

        private void UltraGrid1_SummaryValueChanged(object sender, SummaryValueChangedEventArgs e)
        {
            if (e.SummaryValue.ParentRows.Band.Layout.IsExportLayout)
            {
                Debug.WriteLine("Export Layout have fired the event!");
                return;
            }
        }

        private DataSet GetData()
        {
            DataSet ds = new DataSet();
            DataTable t1 = ds.Tables.Add("Main");
            t1.Columns.Add("Id", typeof(int)).AutoIncrement = true;
            t1.Columns.Add("Type", typeof(string));
            t1.Columns.Add("Quantity", typeof(int));
            t1.Columns.Add("UnitPrice", typeof(double));
            t1.Columns.Add("Price", typeof(double));

            ds = this.AddData(ds);

            return ds;
        }

        private DataSet AddData(DataSet ds)
        {
            ds.Tables["Main"].Rows.Add(new object[] { null, "Type1", 50, 10.2, 510 });
            ds.Tables["Main"].Rows.Add(new object[] { null, "Type2", 5, 90, 450 });
            ds.Tables["Main"].Rows.Add(new object[] { null, "Type3", 20, 32, 640 });
            ds.Tables["Main"].Rows.Add(new object[] { null, "Type1", 12, 79, 948 });
            ds.Tables["Main"].Rows.Add(new object[] { null, "Type2", 40, 10.2, 408 });
            ds.Tables["Main"].Rows.Add(new object[] { null, "Type3", 25, 12, 300 });
            ds.Tables["Main"].Rows.Add(new object[] { null, "Type1", 30, 13, 390 });
            ds.Tables["Main"].Rows.Add(new object[] { null, "Type2", 13, 200, 2600 });
            ds.Tables["Main"].Rows.Add(new object[] { null, "Type3", 60, 15.3, 918 });
            ds.Tables["Main"].Rows.Add(new object[] { null, "Type1", 5, 3000, 15000 });
            ds.Tables["Main"].Rows.Add(new object[] { null, "Type2", 10, 320, 3200 });
            ds.Tables["Main"].Rows.Add(new object[] { null, "Type3", 40, 69, 2760 });
            ds.Tables["Main"].Rows.Add(new object[] { null, "Type1", 24, 40.6, 974.4 });
            ds.Tables["Main"].Rows.Add(new object[] { null, "Type2", 53, 50, 2650 });
            ds.Tables["Main"].Rows.Add(new object[] { null, "Type3", 42, 22, 924 });

            return ds;
        }
    }
}
